"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPages = exports.onPreInit = exports.onCreateWebpackConfig = exports.pluginOptionsSchema = void 0;
var path_1 = __importDefault(require("path"));
var pluginOptionsSchema = function (_a) {
    var Joi = _a.Joi;
    return Joi.object({
        snekResourceId: Joi.string().required(),
        googleAnalytics: Joi.object({
            trackingIds: Joi.array().items(Joi.string())
        })
    });
};
exports.pluginOptionsSchema = pluginOptionsSchema;
var onCreateWebpackConfig = function (_a, pluginOptions) {
    var actions = _a.actions, loaders = _a.loaders, stage = _a.stage, plugins = _a.plugins, getConfig = _a.getConfig;
    return __awaiter(void 0, void 0, void 0, function () {
        var snekResourceId, version, config, babelLoaderRule, babelLoaderWithPlugin;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    snekResourceId = pluginOptions.snekResourceId;
                    if (!snekResourceId) {
                        throw new Error("The plugin option 'snekResourceId' is required. Please add the option to your gatsby-config.js file.");
                    }
                    return [4 /*yield*/, Promise.resolve().then(function () { return __importStar(require('@atsnek/jaen/package.json')); })];
                case 1:
                    version = (_b.sent()).version;
                    config = getConfig();
                    babelLoaderRule = config.module.rules.find(function (rule) { return String(rule.test) === String(/\.(js|mjs|jsx|ts|tsx)$/); });
                    babelLoaderWithPlugin = __assign(__assign({}, babelLoaderRule), { use: function (_a) {
                            var resourceQuery = _a.resourceQuery, issuer = _a.issuer;
                            var babelLoaderOptions = {
                                loader: 'babel-loader',
                                options: {
                                    plugins: [
                                        require.resolve('../../babel-plugin-remove-page-config.js')
                                    ]
                                }
                            };
                            var existingLoaders = babelLoaderRule.use({ resourceQuery: resourceQuery, issuer: issuer });
                            return __spreadArray([babelLoaderOptions], existingLoaders, true);
                        } });
                    config.module.rules = __spreadArray(__spreadArray([], config.module.rules.filter(function (rule) { return String(rule.test) !== String(/\.(js|mjs|jsx|ts|tsx)$/); }), true), [
                        babelLoaderWithPlugin
                    ], false);
                    actions.replaceWebpackConfig(config);
                    if (stage === 'build-html' || stage === 'develop-html') {
                        actions.setWebpackConfig({
                            module: {
                                rules: [
                                    {
                                        test: /filerobot-image-editor/,
                                        use: loaders.null()
                                    },
                                    {
                                        test: /reagraph/,
                                        use: loaders.null()
                                    }
                                ]
                            }
                        });
                    }
                    actions.setWebpackConfig({
                        plugins: [
                            plugins.define({
                                __VERSION__: JSON.stringify(version),
                                __SNEK_RESOURCE_ID__: JSON.stringify(snekResourceId)
                            })
                        ]
                    });
                    return [2 /*return*/];
            }
        });
    });
};
exports.onCreateWebpackConfig = onCreateWebpackConfig;
var onPreInit = function (_a, pluginOptions) {
    var store = _a.store, reporter = _a.reporter;
    return __awaiter(void 0, void 0, void 0, function () {
        var state, manifestPlugin, manifestOptions, gtagPlugin, trackingIds;
        var _b;
        var _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    state = store.getState();
                    manifestPlugin = state.flattenedPlugins.find(function (plugin) { return plugin.name === 'gatsby-plugin-manifest'; });
                    if (!manifestPlugin) return [3 /*break*/, 2];
                    return [4 /*yield*/, resolveManifestOptions({
                            snekResourceId: pluginOptions.snekResourceId,
                            reporter: reporter
                        })];
                case 1:
                    manifestOptions = _d.sent();
                    manifestPlugin.pluginOptions = __assign(__assign({}, manifestPlugin.pluginOptions), manifestOptions);
                    _d.label = 2;
                case 2:
                    gtagPlugin = state.flattenedPlugins.find(function (plugin) { return plugin.name === 'gatsby-plugin-google-gtag'; });
                    if (gtagPlugin) {
                        trackingIds = ((_c = pluginOptions.googleAnalytics) === null || _c === void 0 ? void 0 : _c.trackingIds) || [];
                        if (trackingIds) {
                            (_b = gtagPlugin.pluginOptions.trackingIds).push.apply(_b, trackingIds);
                        }
                    }
                    return [2 /*return*/];
            }
        });
    });
};
exports.onPreInit = onPreInit;
var createPages = function (_a, pluginOptions) {
    var actions = _a.actions, store = _a.store, reporter = _a.reporter;
    return __awaiter(void 0, void 0, void 0, function () {
        var snekResourceId;
        return __generator(this, function (_b) {
            snekResourceId = pluginOptions.snekResourceId;
            // Create JaenFrame slice
            actions.createSlice({
                id: "jaen-frame",
                component: path_1.default.resolve(__dirname, '../../src/slices/jaen-frame.tsx')
            });
            return [2 /*return*/];
        });
    });
};
exports.createPages = createPages;
var resolveManifestOptions = function (_a) {
    var snekResourceId = _a.snekResourceId, reporter = _a.reporter;
    return __awaiter(void 0, void 0, void 0, function () {
        var resource, query, variables, response, json, err_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 3, , 4]);
                    query = "\n  query Manifest($resourceId: String!) {\n    resource(id: $resourceId) {\n      id\n      name\n    }\n  }\n  ";
                    variables = {
                        resourceId: snekResourceId
                    };
                    return [4 /*yield*/, fetch('https://services.snek.at/graphql', {
                            method: 'POST',
                            headers: {
                                'Content-Type': 'application/json'
                            },
                            body: JSON.stringify({ query: query, variables: variables })
                        })];
                case 1:
                    response = _b.sent();
                    return [4 /*yield*/, response.json()];
                case 2:
                    json = _b.sent();
                    if (json.errors) {
                        throw new Error(json.errors[0].message);
                    }
                    resource = json.data.resource;
                    return [3 /*break*/, 4];
                case 3:
                    err_1 = _b.sent();
                    reporter.warn("gatsby-plugin-manifest - failed to fetch resource ".concat(snekResourceId, " from services.snek.at"));
                    resource = {
                        id: 'dev',
                        name: 'Development Resource'
                    };
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/, {
                        name: resource.name,
                        short_name: resource.name,
                        start_url: '/',
                        background_color: "#f7f0eb",
                        theme_color: "#a2466c",
                        display: "standalone",
                        icon: "src/favicon.ico"
                    }];
            }
        });
    });
};
